#!/usr/bin/env python
# coding: utf-8

# In[ ]:


get_ipython().system('pip3 install oaiharvest --ignore-installed')
get_ipython().system('pip3 install mysql')
get_ipython().system('pip3 install html2text')
get_ipython().system('pip3 install python-magic')
get_ipython().system('pip3 install  nbformat')
get_ipython().system('pip3 install --upgrade "pip<10"')
get_ipython().system('pip3 search mysql-connector | grep --color mysql-connector-python')
get_ipython().system('pip3 install --upgrade pip')
get_ipython().system('pip3 install mysql-connector-python-rf')
get_ipython().system('pip3 install urlextract')
get_ipython().system('pip3 install oaiharvest==3.0.0')
get_ipython().system('pip3 install var_dump')


# In[ ]:


get_ipython().system('oai-reg add datacite https://oai.datacite.org/oai')


# In[ ]:


get_ipython().system('oai-harvest datacite')


# In[ ]:


get_ipython().system('oai-harvest   https://oai.datacite.org/oai')


# In[ ]:


#URL OAI-PMH
#https://oai.datacite.org/oai
print('comecou')
get_ipython().system('oai-harvest  http://oai.datacite.org/oai')
print('terminou')


# In[2]:


import glob
from xml.dom import minidom
import re, math
import requests
from pathlib import Path
import sys
from urlextract import URLExtract
import magic
import mysql.connector
import html2text
import matplotlib.pyplot as plt
import numpy as np
import pandas as pd
from var_dump import var_dump
import time
import urllib.request
import json
from collections import namedtuple


# In[ ]:


extractor = URLExtract()
urls = extractor.find_urls("Text with URLs. Let's have URL janlipovsk\ny.cz as https://elements.com an example.")
print(urls)


# #busca de datasets a partir do DOI
# https://api.figshare.com/v2/articles/7796171
# https://zenodo.org/api/records/161298
#     
#     # busca de textos completos a partir do DOI
# https://api.elsevier.com/content/article/doi/10.1016/j.aoas.2018.03.001
#     
# https://api.test.datacite.org/dois/10.23675/ccdc.csd.cc1rzhqy
#     
# https://api.test.datacite.org/dois?query=relatedIdentifiers.relationType:IsSupplementTo&resourceTypeGeneral:Dataset
#             
# https://api.datacite.org/dois

# In[2]:


urllib.request.urlretrieve("https://api.test.datacite.org/dois?page[size]=30&query=relatedIdentifiers.relationType:IsSupplementTo&query=types.resourceTypeGeneral:Dataset", "datacite.json")


# # Quantos registros existem no Datacite

# Total de registros

# In[3]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])


# Total de datasets

# In[4]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30&query=types.resourceTypeGeneral:Dataset", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])


# In[ ]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30&query=publicationYear:2016", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])


# In[ ]:


dict1 = {'title':'AAA','publisher':'','creator':'','dates':'','IDs':'','relIDs':''}
dict1.update({'title': 'teseeee'}) 

urllib.request.urlretrieve("https://api.test.datacite.org/dois?page[size]=30&query=types.resourceTypeGeneral:Dataset", "datacite.json")

request = "https://api.test.datacite.org/dois?page[size]=30&query=types.resourceTypeGeneral:Dataset"
with open('datacite.json') as f:
    data = json.load(f)
    #df=pd.DataFrame(data)

    df = pd.DataFrame.from_records(map(json.loads, f))
df.head(10)

1321270 - 33


# In[4]:


#busca os metadados, de 2015 a 2019, de forma aleatoria
i = 0
#url = "https://api.datacite.org/dois?page[size]=3000&query=types.resourceTypeGeneral:Dataset"
for ano in range(2008,2019):
    url = "https://api.datacite.org/dois?page[size]=300&query=publicationYear:"+str(ano)+"&random=true"
    print(ano)
    while True:
        urllib.request.urlretrieve(url, "metadados/datacite"+str(ano)+"-"+str(i)+".json")
        with open("metadados/datacite"+str(ano)+"-"+str(i)+".json") as f:
            data = json.load(f)
        if not data['links']['next']:
            break
        else:
            time.sleep(0.5)
            i = i + 1
            if url == data['links']['next']:
                break
            else:
                url = data['links']['next']
                print('buscando '+ url)


# In[5]:


#import pandas
#pandas.read_json("datacite.json").to_excel("outputIngrid.xlsx")
df = pd.DataFrame(columns=['title','publisher','creator','dates','DOI','relType','relIDType','relIDValue','ISSN', 'container-title', 'relPublisher', 'relDOIAgency'])
rows_list = []
#recuperar registros do json, navegando pelas paginas indicadas no campo links.next
import glob

for filename in glob.glob('metadados/*.json'):    
#for filename in glob.glob('metadados/datacite2019-1.json'):    
    with open(filename) as f:            
        data = json.load(f)
        #var_dump(data)
        print(data['meta']['total'])
        print(data['links']['next'])
        for id in data['data']:
            #var_dump(id)
            title = ''
            for field in id['attributes']['titles']:
                try:                                        
                    title += field['title']
                    #var_dump(field)
                except Exception as e: 
                    print(e)
                    #var_dump(id)
            #print("titulo:"+title)         
            creator = ''
            for field in id['attributes']['creators']:
                try:                                        
                    if field['name']:
                        creator += field['name']
                    else:
                        creator += field['familyName'] + field['givenName']
                    #var_dump(field)
                except  Exception as e: 
                    print(e)
                    #var_dump(id)
            try:                
                #print('datas')
                datas = ''
                for dataAux in id['attributes']['dates']:
                    if dataAux['dateType'] == 'Issued':
                        datas += dataAux['date'] +" "                       
            except Exception as e: 
                    print(e)
                    #var_dump(id)
            publisher = ''
            if id['attributes']['publisher'] is not None:
                publisher = id['attributes']['publisher']
           
            if id['attributes']['doi'] is not None:
                doi= id['attributes']['doi']
            else:
                doi = ''                        
                
            if id['attributes']['relatedIdentifiers'] is not None:
                for field in id['attributes']['relatedIdentifiers']:
                    #IsCitedBy, IsSupplementTo, IsPartOf, IsReferencedBy;
                    if (field['relationType'] == 'IsCitedBy' or field['relationType'] == 'IsSupplementTo'                         or field['relationType'] == 'IsPartOf' or field['relationType'] == 'IsReferencedBy')                         and (field['relatedIdentifierType']=='DOI'):
                            #print(field['relationType'] + " " + field['relatedIdentifierType']+" "+ field['relatedIdentifier'])
                            relType = field['relationType']
                            relIDType = field['relatedIdentifierType']
                            relIDValue = field['relatedIdentifier']
                            dict1 = {'title':'A','publisher':'A','creator':'A','dates':'A',                                     'DOI':'A','relType':'A','relIDType':'A','relIDValue':'A',                                    'ISSN':'a', 'container-title':'a', 'relPublisher':'a'}
                            dict1.update({'title': title}) 
                            dict1.update({'creator': creator}) 
                            dict1.update({'dates': datas}) 
                            dict1.update({'publisher': publisher}) 
                            dict1.update({'relType': relType}) 
                            dict1.update({'relIDType': relIDType}) 
                            dict1.update({'relIDValue': relIDValue}) 
                            if relIDType == "DOI":
                                try:
                                    url_agency = 'https://api.crossref.org/works/'+relIDValue + '/agency'
                                    print('buscando:'+url_agency)
                                    urllib.request.urlretrieve(url_agency, 'agency.json')
                                    with open('agency.json') as meta:
                                        documentoA = json.load(meta)
                                        doiAgency = documentoA['message']['agency']['id'] 
                                        print("Agencia="+doiAgency)
                                        if doiAgency== 'datacite':                                            
                                            url_metadados = 'https://api.datacite.org/dois/'+relIDValue                                                                
                                            print('buscando:'+url_metadados)
                                            urllib.request.urlretrieve(url_metadados, 'metadados.json')
                                            with open('metadados.json') as meta:
                                                documento = json.load(meta)
                                                #var_dump(documento['message']);
                                                nome_publisher = documento['data']['attributes']['publisher']                                                
                                                print("Publisher:"+nome_publisher, end=', ')  
                                                titulo =  documento['data']['attributes']['titles'][0]['title']
                                                print("Título:"+titulo, end=', ')       
                                                issn = 'N/A'
                                                dict1.update({'ISSN': issn})
                                                dict1.update({'container-title': titulo})
                                                dict1.update({'relPublisher': nome_publisher})
                                        if doiAgency == 'crossref':                                     
                                            url_metadados = 'https://api.crossref.org/works/'+relIDValue                                                                
                                            print('buscando:'+url_metadados)
                                            urllib.request.urlretrieve(url_metadados, 'metadados.json')
                                            with open('metadados.json') as meta:
                                                documento = json.load(meta)
                                                #var_dump(documento['message']);
                                                nome_publisher = documento['message']['publisher']
                                                titulo =  documento['message']['title'][0]
                                                print("Título:"+titulo, end=' ')
                                                print("Publisher:"+nome_publisher, end=' !')         
                                                issn = documento['message']['ISSN']
                                                dict1.update({'ISSN': issn})
                                                dict1.update({'container-title': titulo})
                                                dict1.update({'relPublisher': nome_publisher})
                                except Exception as e: 
                                    print(e)
                                    dict1.update({'relPublisher': 'DOI invalido'})
                            dict1.update({'DOI': doi}) 
                            rows_list.append(dict1)
            else:
                relType = ''
                relIDType = ''
                relIDValue = ''
                doiAgency = ''
                dict1 = {'title':'A','publisher':'A','creator':'A','dates':'A','DOI':'A','relType':'A','relIDType':'A','relIDValue':'A', 'relDOIAgency':'A'}
                dict1.update({'title': title}) 
                dict1.update({'creator': creator}) 
                dict1.update({'dates': datas}) 
                dict1.update({'publisher': publisher}) 
                dict1.update({'relType': relType}) 
                dict1.update({'relIDType': relIDType}) 
                dict1.update({'relIDValue': relIDValue}) 
                dict1.update({'DOI': doi})                 
                dict1.update({'relDOIAgency': doiAgency}) 
                rows_list.append(dict1)                            

df = pd.DataFrame(rows_list)   
df.head(10)
df.to_excel("outputTodos.xlsx")


# In[11]:


df.head(10)


# In[ ]:





# # Quantos registros são de datasets

# In[7]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30&query=types.resourceTypeGeneral:Dataset", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])


# # Quantos registros tem o campo 'IsCitedBy'

# In[8]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30&query=relatedIdentifiers.relationType:IsCitedBy", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])


# # Quantos datasets tem o campo 'IsSupplementTo'

# In[9]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30&query=types.resourceTypeGeneral:Dataset&query=relatedIdentifiers.relationType:IsSupplementTo", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])


# # Quantos datasets tem relatedIdentifierType = DOI

# In[10]:


urllib.request.urlretrieve("https://api.datacite.org/dois?page[size]=30&query=types.resourceTypeGeneral:Dataset&query=relatedIdentifiers.relatedIdentifierType:DOI", "datacite.json")
with open('datacite.json') as f:
    data = json.load(f)
    with open('datacite.json') as f:
        data = json.load(f)
        print(data['meta']['total'])

